/* -*- mode: c++; -*- */
#ifndef _JPG_
#define _JPG_

#include "image.hpp"

class JPEG : public Image
{

private:
  int compress ;
  J_COLOR_SPACE colorspace ;

public:

  JPEG () : Image () { this->compress = 90 ; } ;
  JPEG ( int w, int h, int c, J_COLOR_SPACE cs, int cp ) : Image ( w, h, c ) {
    this->components = c ;
    this->colorspace = cs ;
    this->compress = cp ;
  } ;

  virtual int load ( const char * filename ) ;
  virtual int save ( const char * filename ) ;
  int exportToSTL ( const char * filename, int skip_x, int skip_y,
		    bool binary ) ;
  void setMM ( float width, float height, float depth ) ;
  int RGBtoGrayscale ( void ) ;

  void setCompression( int cmpr ) { this->compress = cmpr ; } ;
} ;

#endif
