/* -*- mode: c++; -*- */
#ifndef _STL_
#define _STL_

#include "image.hpp"
#include "v3d.hpp"

#include <vector>

typedef std::vector < Facet * > vecFacet ;

class STL : public Image
{

  //  int depth ;
  vecFacet triangles ;
  Vertex min ;
  bool binmode ;

public:

  STL () : Image () { this->binmode = false ; } ;
  STL ( int w, int h, int c ) : Image ( w, h, c ) {
    this->components = c ;
    this->binmode = false ;
  } ;

  virtual ~STL () {
    /* tu zwalnia pami this->triangles !!! */
    for ( vecFacet::iterator it = this->triangles.begin() ;
	  it != this->triangles.end() ; ++ it ) {
      //Facet * ffd = static_cast < Facet * >( * it ) ;
      //delete ffd ;
      delete ( * it ) ; 
    }

    this->triangles.clear() ;
  } ;

  virtual int load ( const char * filename ) ;
  virtual int save ( const char * filename ) ;
  // Konwersja na int, ustawienie wymiarw JPEG-a ( min 400 krtszy bok )
  // i gbi szaroci (min 2)
  void setPX ( float fwidth, float fheight, float fdepth ) ;
  int exportToJPEG ( const char * filename, int cmpr ) ;
  int numOfTriangles ( void ) { return this->triangles.size() ; } ;
  void toBinmode ( void ) { this->binmode = true ; } ;

private:
  inline void drawHLineJPEG( float x1, float x2, int y, float z1, float z2 ) ;
  bool popFrontValue ( std::string & str, std::string & val ) ;
} ;

void printHelp ( void ) ;

inline int irndf( float a ) ;

#endif
