#include <cstdlib>
#include <iostream>

#include "v3d.hpp"

using namespace std;

void
Facet::normalize ( void )
{
  Vertex /*jmp,*/ v1, v2;
  /*  
      0. Kolejno punktw powinna by w tym momencie poprawna
      bo normalna bdzie skierowana w z stron!
      ( zasada ktrej tam rki )
  */

  // 1. Oblicz "prawdziwe" wektory
  v1.set( this->vertexes[ 1 ].x - this->vertexes[ 0 ].x,
	  this->vertexes[ 1 ].y - this->vertexes[ 0 ].y,
	  this->vertexes[ 1 ].z - this->vertexes[ 0 ].z ) ;
  v2.set( this->vertexes[ 2 ].x - this->vertexes[ 1 ].x,
	  this->vertexes[ 2 ].y - this->vertexes[ 1 ].y,
	  this->vertexes[ 2 ].z - this->vertexes[ 1 ].z ) ;

  // 2. Oblicz cross product, i zachowaj w this->normal
  /*
    Vec3 cross(const Vec3& v1, const Vec3& v2) {
    return Vec3(v1.y * v2.z - v1.z * v2.y,
    v1.z * v2.x - v1.x * v2.z,
    v1.x * v2.y - v1.y * v2.x);
    }

  */
  this->normal.set( v1.y * v2.z - v1.z * v2.y,
		    v1.x * v2.z - v1.z * v2.x,
		    v1.x * v2.y - v1.y * v2.x ) ;

  // 3. normalizuj this->normal
  this->normal.calcuLen() ;
  if( isnan( this->normal.len ) ) {
    cerr << "normalize: isnan." << endl ;
    return ;
  }

  /*
    float inv = 1.0f / this->normal.len ;
    this->normal.x *= inv ;
    this->normal.y *= inv ;
    this->normal.z *= inv ;
  */
  this->normal.x /= this->normal.len ;
  this->normal.y /= this->normal.len ;
  this->normal.z /= this->normal.len ;

}

